"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchRequest,
    avro_parse,
    load_schema,
)


class SearchReadsRequest(SearchRequest):
    """
    This request maps to the body of `POST /reads/search` as JSON.  If a
    reference is specified, all queried `ReadGroup`s must be aligned
    to `ReferenceSet`s containing that same `Reference`. If no
    reference is specified, all `ReadGroup`s must be aligned to the
    same `ReferenceSet`.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "readGroupIds",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.SearchReadsRequest": ga4gh_3_1_1.SearchReadsRequest,
        }

    __slots__ = [
        "readGroupIds",
        "end",
        "pageSize",
        "pageToken",
        "referenceId",
        "start",
    ]

    def __init__(
        self,
        readGroupIds,
        end=None,
        pageSize=None,
        pageToken=None,
        referenceId=None,
        start=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchReadsRequest model.

        :param readGroupIds:
            The ReadGroups to search. At least one readGroupId must be specified.
        :type readGroupIds: list[str]
        :param end:
            The end position (0-based, exclusive) of this query.   If a reference
            is specified, this defaults to the   reference's length.
        :type end: None | int
        :param pageSize:
            Specifies the maximum number of results to return in a single page.
            If unspecified, a system default will be used.
        :type pageSize: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets.   To get the next page of results, set this
            parameter to the value of   `nextPageToken` from the
            previous response.
        :type pageToken: None | str
        :param referenceId:
            The reference to query. Leaving blank returns results from all
            references, including unmapped reads - this could be very
            large.
        :type referenceId: None | str
        :param start:
            The start position (0-based) of this query.   If a reference is
            specified, this defaults to 0.   Genomic positions are
            non-negative integers less than reference length.
            Requests spanning the join of circular genomes are
            represented as   two requests one on each side of the join
            (position 0).
        :type start: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
